/**
* This file was @generated using pocketbase-typegen
*/

export enum Collections {
	Accounts = "accounts",
	AccountsList = "accountsList",
	Companies = "companies",
	CompanyTransactions = "companyTransactions",
	Settings = "settings",
	Transactions = "transactions",
}

// Alias types for improved usability
export type IsoDateString = string
export type RecordIdString = string
export type HTMLString = string

// System fields
export type BaseSystemFields<T = never> = {
	id: RecordIdString
	created: IsoDateString
	updated: IsoDateString
	collectionId: string
	collectionName: Collections
	expand?: T
}

export type AuthSystemFields<T = never> = {
	email: string
	emailVisibility: boolean
	username: string
	verified: boolean
} & BaseSystemFields<T>

// Record types for each collection

export type AccountsRecord = {
	accountNumber?: string
	firstName: string
	lastName: string
	grade: string
	lastCheckIn?: IsoDateString
	company?: RecordIdString
	shift: string
	wageFactor: number
}

export type AccountsListRecord<Tbalance = unknown, Tname = unknown> = {
	accountNumber?: string
	name?: null | Tname
	grade: string
	lastCheckIn?: IsoDateString
	balance?: null | Tbalance
}

export type CompaniesRecord = {
	accountNumber?: string
	name: string
	earlyShiftPayed?: IsoDateString
	lateShiftPayed?: IsoDateString
}

export type CompanyTransactionsRecord = {
	account: RecordIdString
	label: string
	amount?: number
}

export type SettingsRecord = {
	minWage: number
	incomeTax: number
	incomeTaxRecipient: RecordIdString
	maxWageFactor: number
	radioUrl: string
}

export type TransactionsRecord = {
	account: RecordIdString
	label: string
	amount?: number
}

// Response types include system fields and match responses from the PocketBase API
export type AccountsResponse<Texpand = unknown> = Required<AccountsRecord> & BaseSystemFields<Texpand>
export type AccountsListResponse<Tbalance = unknown, Tname = unknown, Texpand = unknown> = Required<AccountsListRecord<Tbalance, Tname>> & BaseSystemFields<Texpand>
export type CompaniesResponse<Texpand = unknown> = Required<CompaniesRecord> & AuthSystemFields<Texpand>
export type CompanyTransactionsResponse<Texpand = unknown> = Required<CompanyTransactionsRecord> & BaseSystemFields<Texpand>
export type SettingsResponse<Texpand = unknown> = Required<SettingsRecord> & BaseSystemFields<Texpand>
export type TransactionsResponse<Texpand = unknown> = Required<TransactionsRecord> & BaseSystemFields<Texpand>

// Types containing all Records and Responses, useful for creating typing helper functions

export type CollectionRecords = {
	accounts: AccountsRecord
	accountsList: AccountsListRecord
	companies: CompaniesRecord
	companyTransactions: CompanyTransactionsRecord
	settings: SettingsRecord
	transactions: TransactionsRecord
}

export type CollectionResponses = {
	accounts: AccountsResponse
	accountsList: AccountsListResponse
	companies: CompaniesResponse
	companyTransactions: CompanyTransactionsResponse
	settings: SettingsResponse
	transactions: TransactionsResponse
}